<template>
  <rui-form :errors="errors"
            model="path"
            :loading="loading"
            @cancel="$emit('cancel')"
            @submit.prevent="save">
    <gpa-path-inputs :name="inputs.name"
                     :stroke-width="inputs.strokeWidth"
                     :stroke-color="inputs.strokeColor"
                     :background-color="inputs.backgroundColor"
                     :stroke-style-preset="inputs.strokeStylePreset"
                     :path-id="inputs.id"
                     :layer-id="inputs.layerId"
                     @change="updateInput" />
  </rui-form>
</template>

<script>
import RuiForm from '@experiments-labs/rise_ui/src/components/Form/Form.vue'

import GpaPathInputs from './_Inputs.vue'
import Path from '../../../../classes/models/Path'

export default {
  name: 'GpaPathForm',
  emits: [
    'cancel',
    'saved',
  ],
  components: { RuiForm, GpaPathInputs },
  props: {
    // Mandatory; this form is not for path creation, only edition.
    path: { required: true, type: Path },
  },
  data () {
    return {
      loading: false,
      inputs: { ...this.resetInputs() },
      errors: null,
    }
  },
  methods: {
    resetInputs () {
      return {
        id: this.path.id,
        name: this.path.name || '',
        strokeColor: this.path.strokeColor || '0,0,0,1',
        backgroundColor: this.path.backgroundColor || '0,0,0,0.2',
        strokeWidth: this.path.strokeWidth || 1,
        strokeStylePreset: this.path.strokeStylePreset || null,
        layerId: this.path.layerId || null,
      }
    },
    updateInput ({ key, value }) { this.inputs[key] = value },
    save () {
      this.errors = null
      const payload = {
        id: this.inputs.id,
        name: this.inputs.name,
        stroke_color: this.inputs.strokeColor,
        background_color: this.inputs.backgroundColor,
        stroke_width: this.inputs.strokeWidth,
        stroke_style_preset: this.inputs.strokeStylePreset,
        layer_id: this.inputs.layerId,
      }
      this.loading = true
      this.$store.dispatch('updatePath', payload)
        .then(() => { this.$emit('saved', this.path) })
        .catch((error) => { this.errors = error })
        .then(() => { this.loading = false })
    },
  },
}
</script>
